/*
* ASIX up_control.dll, example 
* It is distributed as-is, without any warranties.
* http://www.asix.net/
*
* version 1.0, October 2020
* 
*/

#include <stdio.h>
#include "UP_control.h"


int main()
{
 int LoadRes;
 char dll_path[] ="C:\\Program Files (x86)\\ASIX\\UP\\up_control.dll";

 int prog_list[20];
 int prog_list_count;
 int i; 
 int FuncRes;
 
 

 printf("\nASIX up_control.dll programmers list example\n");

 // load the library
 LoadRes=Load_UP_control_dll(dll_path);

 if (LoadRes == DLL_LOAD_OK) {
  printf("up_control.dll load OK\n");
 }           
 else {
  printf("\nup_control.dll load error, %i\n",LoadRes);
  return 1;
 }
 
 
 FuncRes=UP_GetProgList(PROG_FORTE, prog_list, 20, &prog_list_count);
 printf("UP_GetProgList result: %d\n", FuncRes);
 if(prog_list_count < 1) {
  printf("No FORTE programmer found.\n");
 }
 for(i=0;i<prog_list_count;i++) {
  printf("Found FORTE S/N %06X\n", prog_list[i]);
 }

 // -----
 UP_GetProgList(PROG_PRESTO, prog_list, 20, &prog_list_count);
 if(prog_list_count < 1) {
  printf("No PRESTO programmer found.\n");
 }
 for(i=0;i<prog_list_count;i++) {
  printf("Found PRESTO S/N %06X\n", prog_list[i]);
 }


 return 0;
}
