/*
* ASIX up_control.dll, example 
* It is distributed as-is, without any warranties.
* http://www.asix.net/
*
* version 1.0, September 2019
* 
*/

#include <stdio.h>
#include "UP_control.h"


int main()
{
 int LoadRes;
 int FuncRes, PrintRes;
 int ProgressBar;
 char dll_path[] ="C:\\Program Files (x86)\\ASIX\\UP\\up_control.dll";
// char dll_path[] ="up_control.dll";
 char ppr_path[] ="C:\\dokumenty\\test\\PIC18F67J10\\PIC18F67J10.PPR"; 
 char file_path[] ="";

 printf("\nASIX up_control.dll programming example\n");

 // load the library
 LoadRes=Load_UP_control_dll(dll_path);

 if (LoadRes == DLL_LOAD_OK) {
  printf("up_control.dll load OK\n");
 }           
 else {
  printf("\nup_control.dll load error, %i\n",LoadRes);
  return 1;
 }


 // prog config UP
 FuncRes = UP_ProgConfig(0, ppr_path, SET_PROG_FROM_PROJECT, 0, file_path, file_path);
 printf("UP_ProgConfig result: %i\n",FuncRes);
 if (FuncRes !=0) {return 2;}

 // program it
 FuncRes = UP_Prog(0, 1, 1, 1, 1);
 printf("UP_Prog result: %i\n",FuncRes);
 if (FuncRes !=0) {return 2;}

 FuncRes = UP_ProgState(0, &ProgressBar);
 while (FuncRes==PROG_STATE_BUSY) {
  FuncRes=UP_ProgState(0, &ProgressBar);
  printf("\rUP_ProgState result: %i, progress: %i",FuncRes, ProgressBar); 
  Sleep(50);
 } 

 printf("\n");
 printf("Finished, last error code %i\n",UP_LastErrorCode(0));

 return 0;
}
