unit mainf;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TUPProgForm = class(TForm)
    LabelInfo: TLabel;
    TimerProgResult: TTimer;
    OpenPPR: TOpenDialog;
    Programmer: TRadioGroup;
    Panel1: TPanel;
    LoadPPR: TButton;
    ProgType: TRadioGroup;
    Panel2: TPanel;
    ButtonProg: TButton;
    Panel3: TPanel;
    LabelResultProg2: TLabel;
    LabelResultProg1: TLabel;
    LabelResultProg0: TLabel;
    LabelResultProg3: TLabel;
    EditProgSN: TEdit;
    Label1: TLabel;
    Panel4: TPanel;
    ButtonManualSN: TButton;
    EditManualSN: TEdit;
    UseManualSN: TCheckBox;
    ButtonVerify: TButton;
    ButtonDiffProg: TButton;
    ButtonErase: TButton;
    ButtonBlankCheck: TButton;
    ButtonRead: TButton;
    Panel5: TPanel;
    ButtonProgList: TButton;
    ComboProgList: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure ButtonProgClick(Sender: TObject);
    procedure TimerProgResultTimer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure LoadPPRClick(Sender: TObject);
    procedure ButtonManualSNClick(Sender: TObject);
    procedure ButtonVerifyClick(Sender: TObject);
    procedure ButtonDiffProgClick(Sender: TObject);
    procedure ButtonEraseClick(Sender: TObject);
    procedure ButtonBlankCheckClick(Sender: TObject);
    procedure ButtonReadClick(Sender: TObject);
    procedure ButtonProgListClick(Sender: TObject);
    procedure ButtonFreeLibClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


const
//  up_control_path='up_control.dll';
  up_control_path='C:\Program Files (x86)\ASIX\UP\up_control.dll';
//  up_control_path='C:\Program Files (x86)\ASIX\UP\up_control64.dll';
  // ---------------
  // UP_control.dll consts
  ERR_NONE=0;
  ERR_PROG_BUSY=1;
  ERR_UP_MISSING=2;
  ERR_WRONG_PROG_INDEX=3;
  ERR_NOT_CONFIGURED=4;
  ERR_FILE_DOES_NOT_EXIST=5;
  ERR_DRIVER=6;
  // ---------------
  PROG_STATE_DONE=0;
  PROG_STATE_BUSY=1;
  PROG_STATE_NOT_USED=2;
  PROG_STATE_WRONG_INDEX=3;
  // ---------------
  SET_PROG_FROM_PROJECT=0;
  SET_PROG_PRESTO=1;
  SET_PROG_FORTE=2;
  // ---------------
  PROG_PRESTO=1;
  PROG_FORTE=2;
  // ---------------
  MAX_PROGS=4;
  // --------------


var
  UPProgForm: TUPProgForm;
  WaitingForFinish:boolean=false;
  // ------------
  UP_control_dll:THandle;

  UP_Prog: function (Prog_index:integer; code:boolean; data:boolean; boot:boolean; cfg:boolean):integer; stdcall;
  UP_DiffProg: function (Prog_index:integer; code:boolean; data:boolean; boot:boolean; cfg:boolean):integer; stdcall;
  UP_Erase: function (Prog_index:integer; code:boolean; data:boolean; boot:boolean):integer; stdcall;
  UP_BlankCheck: function (Prog_index:integer; code:boolean; data:boolean; boot:boolean; cfg:boolean):integer; stdcall;
  UP_Verify: function (Prog_index:integer; code:boolean; data:boolean; boot:boolean; cfg:boolean):integer; stdcall;
  UP_Read: function (Prog_index:integer; code:boolean; data:boolean; boot:boolean; cfg:boolean):integer; stdcall;

  UP_ProgState: function (Prog_index:integer; var ProgressBarValue:integer):integer; stdcall;
  UP_LastErrorCode: function (prog_index:integer):integer; stdcall;
  UP_ProgConfig: function (prog_index:integer; UP_project:PAnsiChar; prog_type:integer; prog_SN:integer; NewDataFile:PAnsiChar; EEFile:PAnsiChar):integer; stdcall;
  UP_SetManualSN: function (prog_index:integer; DefineSN:boolean; SN:integer):integer;

  UP_GetProgList: function (prog_type: integer; Pbuf: pIntegerArray; count:integer; var count_returned:integer):integer;  stdcall;

  UP_CleanUp: function :integer;  stdcall;
  // ------------

implementation

{$R *.dfm}

procedure TUPProgForm.ButtonBlankCheckClick(Sender: TObject);
begin
 if WaitingForFinish then exit; // when user wants to close the form, we will not start a new work

 LabelInfo.Caption:='BlankCheck, exit code: '+IntToStr(UP_BlankCheck(Programmer.ItemIndex, true, true, true, true));
end;

procedure TUPProgForm.ButtonDiffProgClick(Sender: TObject);
begin
 if WaitingForFinish then exit; // when user wants to close the form, we will not start a new work

 LabelInfo.Caption:='DiffProg, exit code: '+IntToStr(UP_DiffProg(Programmer.ItemIndex, true, true, true, true));
end;

procedure TUPProgForm.ButtonEraseClick(Sender: TObject);
begin
 if WaitingForFinish then exit; // when user wants to close the form, we will not start a new work

 LabelInfo.Caption:='Erase, exit code: '+IntToStr(UP_Erase(Programmer.ItemIndex, true, true, true));
end;

procedure TUPProgForm.ButtonFreeLibClick(Sender: TObject);
begin
 // I get rid of the timer, not to call the library after I free it
 TimerProgResult.Enabled:=false;

 if FreeLibrary(UP_control_dll) then
  LabelInfo.Caption:='FreeLibrary OK'
 else
  LabelInfo.Caption:='FreeLibrary FAILED';

 UP_control_dll:=0;
end;

procedure TUPProgForm.ButtonManualSNClick(Sender: TObject);
var manual_SN:integer;
begin
 if WaitingForFinish then exit; // when user wants to close the form, we will not start a new work

 try
  manual_SN:=StrToInt(EditManualSN.Text);
 except
  LabelInfo.Caption:='Wrong SN format';
  exit;
 end;

 LabelInfo.Caption:='UP_SetManualSN result: '+ IntToStr(UP_SetManualSN(Programmer.ItemIndex, UseManualSN.Checked, manual_SN));
end;

procedure TUPProgForm.ButtonProgClick(Sender: TObject);
begin
 if WaitingForFinish then exit; // when user wants to close the form, we will not start a new work

 LabelInfo.Caption:='Prog, exit code: '+IntToStr(UP_Prog(Programmer.ItemIndex, true, true, true, true));
end;

procedure TUPProgForm.ButtonProgListClick(Sender: TObject);
 var
 PBuffer:PIntegerArray;
 progs: array [0..9] of integer;
 FuncRes, count, i:integer;
begin

 PBuffer:=@progs;
 ComboProgList.Items.Clear;

 // check connected FORTE programmers
 FuncRes:=UP_GetProgList(PROG_FORTE, PBuffer, 10, count);
 LabelInfo.Caption:='UP_GetProgList result: '+ IntToStr(FuncRes);

 // list the programmers
 if FuncRes=ERR_NONE then
  begin
   for i := 0 to count-1 do
    ComboProgList.Items.Add('FORTE S/N '+IntToHex(progs[i],6));
  end;

 // check connected PRESTO programmers
 FuncRes:=UP_GetProgList(PROG_PRESTO, PBuffer, 10, count);
 LabelInfo.Caption:=LabelInfo.Caption+', '+ IntToStr(FuncRes);

 // list the programmers
 if FuncRes=ERR_NONE then
  begin
   for i := 0 to count-1 do
    ComboProgList.Items.Add('PRESTO S/N '+IntToHex(progs[i],6));
  end;

 if ComboProgList.Items.Count=0 then
  ComboProgList.Items.Add('not found');
 ComboProgList.ItemIndex:=0;
end;

procedure TUPProgForm.ButtonReadClick(Sender: TObject);
begin
 if WaitingForFinish then exit; // when user wants to close the form, we will not start a new work

 LabelInfo.Caption:='Read, exit code: '+IntToStr(UP_Read(Programmer.ItemIndex, true, true, true, true));
end;

procedure TUPProgForm.ButtonVerifyClick(Sender: TObject);
begin
 if WaitingForFinish then exit; // when user wants to close the form, we will not start a new work

 LabelInfo.Caption:='Verify, exit code: '+IntToStr(UP_Verify(Programmer.ItemIndex, true, true, true, true));
end;

procedure TUPProgForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
 var prog_busy:boolean;
     i, ProgProgress:integer;
     ExitCode:cardinal;
begin

 // disable timer
 TimerProgResult.Enabled:=false;

 // user wants to close the form, wait until all programmings are finished
 WaitingForFinish:=true;
 Caption:='Waiting for programmers work to finish';
 prog_busy:=true;
 while prog_busy do
  begin
   prog_busy:=false;
   for i := 0 to MAX_PROGS-1 do
    begin
     if UP_ProgState(i, ProgProgress)=PROG_STATE_BUSY then
      prog_busy:=true;
    end;
   Application.ProcessMessages;
  end;

 // before FreeLibrary, UP_CleanUp has to be called
 UP_CleanUp;
 FreeLibrary(UP_control_dll);
end;

procedure TUPProgForm.FormCreate(Sender: TObject);
begin

 // load UP_control.dll
// UP_control_dll := LoadLibrary('up_control.dll');  // the up_control.dll path have to be set in Windows path variable, or the application have to be in the UP installation directory
 UP_control_dll := LoadLibrary(up_control_path);
 if UP_control_dll=0 then begin ShowMessage('Error loading the UP_control.dll library.'); halt(1); end;

 // get addresses of the functions included in the dll
 UP_Prog := GetProcAddress(UP_control_dll, 'UP_Prog');
 if @UP_Prog=nil then ShowMessage('Error loading the UP_Prog function from UP_control.dll library.');
 UP_DiffProg := GetProcAddress(UP_control_dll, 'UP_DiffProg');
 if @UP_DiffProg=nil then ShowMessage('Error loading the UP_DiffProg function from UP_control.dll library.');
 UP_Erase := GetProcAddress(UP_control_dll, 'UP_Erase');
 if @UP_Erase=nil then ShowMessage('Error loading the UP_Erase function from UP_control.dll library.');
 UP_BlankCheck := GetProcAddress(UP_control_dll, 'UP_BlankCheck');
 if @UP_BlankCheck=nil then ShowMessage('Error loading the UP_BlankCheck function from UP_control.dll library.');
 UP_Verify := GetProcAddress(UP_control_dll, 'UP_Verify');
 if @UP_Verify=nil then ShowMessage('Error loading the UP_Verify function from UP_control.dll library.');
 UP_Read := GetProcAddress(UP_control_dll, 'UP_Read');
 if @UP_Read=nil then ShowMessage('Error loading the UP_Read function from UP_control.dll library.');

 UP_ProgState := GetProcAddress(UP_control_dll, 'UP_ProgState');
 if @UP_ProgState=nil then ShowMessage('Error loading the UP_ProgState function from UP_control.dll library.');
 UP_LastErrorCode := GetProcAddress(UP_control_dll, 'UP_LastErrorCode');
 if @UP_LastErrorCode=nil then ShowMessage('Error loading the UP_LastErrorCode function from UP_control.dll library.');
 UP_ProgConfig := GetProcAddress(UP_control_dll, 'UP_ProgConfig');
 if @UP_ProgConfig=nil then ShowMessage('Error loading the UP_ProgConfig function from UP_control.dll library.');
 UP_SetManualSN := GetProcAddress(UP_control_dll, 'UP_SetManualSN');
 if @UP_SetManualSN=nil then ShowMessage('Error loading the UP_SetManualSN function from UP_control.dll library.');

 UP_GetProgList := GetProcAddress(UP_control_dll, 'UP_GetProgList');
 if @UP_GetProgList=nil then ShowMessage('Error loading the UP_GetProgList function from UP_control.dll library.');

 UP_CleanUp := GetProcAddress(UP_control_dll, 'UP_CleanUp');
 if @UP_CleanUp=nil then ShowMessage('Error loading the UP_CleanUp function from UP_control.dll library.');

 TimerProgResult.Enabled:=true;
end;


procedure TUPProgForm.LoadPPRClick(Sender: TObject);
var prog_SN:integer;
    CharPointer:PAnsiChar;
begin
 CharPointer:=nil;

 try
  prog_SN:=StrToInt(EditProgSN.Text);
 except
  LabelInfo.Caption:='Wrong SN format';
  exit;
 end;

 // Delphi OpenDialog seems to work in 32bit application version only
 if OpenPPR.Execute then
  begin
   LabelInfo.Caption:='UP_ProgConfig result: '+ IntToStr(UP_ProgConfig(Programmer.ItemIndex , PAnsiChar(AnsiString(OpenPPR.FileName)),ProgType.ItemIndex , prog_SN,CharPointer,CharPointer));
  end;
end;

procedure TUPProgForm.TimerProgResultTimer(Sender: TObject);
var state, ProgProgress:integer;
begin

 // programmer 0
 state:=UP_ProgState(0, ProgProgress);
 case state of
  PROG_STATE_DONE: LabelResultProg0.Caption:='Prog[0] -  done, result: ' + IntToStr(UP_LastErrorCode(0));
  PROG_STATE_BUSY: LabelResultProg0.Caption:='Prog[0] - busy, '+IntToStr(ProgProgress)+' %';
  PROG_STATE_NOT_USED: LabelResultProg0.Caption:='Prog[0] - unknown state';
  else LabelResultProg0.Caption:='Prog[0] - Programmer not defined';
 end;

 // programmer 1
 state:=UP_ProgState(1, ProgProgress);
 case state of
  PROG_STATE_DONE: LabelResultProg1.Caption:='Prog[1] -  done, result: ' + IntToStr(UP_LastErrorCode(1));
  PROG_STATE_BUSY: LabelResultProg1.Caption:='Prog[1] - busy, '+IntToStr(ProgProgress)+' %';
  PROG_STATE_NOT_USED: LabelResultProg1.Caption:='Prog[1] - unknown state';
  else LabelResultProg1.Caption:='Prog[1] - Programmer not defined';
 end;

 // programmer 2
 state:=UP_ProgState(2, ProgProgress);
 case state of
  PROG_STATE_DONE: LabelResultProg2.Caption:='Prog[2] -  done, result: ' + IntToStr(UP_LastErrorCode(2));
  PROG_STATE_BUSY: LabelResultProg2.Caption:='Prog[2] - busy, '+IntToStr(ProgProgress)+' %';
  PROG_STATE_NOT_USED: LabelResultProg2.Caption:='Prog[2] - unknown state';
  else LabelResultProg2.Caption:='Prog[2] - Programmer not defined';
 end;

 // programmer 3
 state:=UP_ProgState(3, ProgProgress);
 case state of
  PROG_STATE_DONE: LabelResultProg3.Caption:='Prog[3] -  done, result: ' + IntToStr(UP_LastErrorCode(3));
  PROG_STATE_BUSY: LabelResultProg3.Caption:='Prog[3] - busy, '+IntToStr(ProgProgress)+' %';
  PROG_STATE_NOT_USED: LabelResultProg3.Caption:='Prog[3] - unknown state';
  else LabelResultProg1.Caption:='Prog[3] - Programmer not defined';
 end;
end;

end.
